#!/bin/bash
#
# Generate an acquisition file for SEM46 based on a model generated by
# build_simple_synthetic_model_*D.py.
#
# Francois Lavoue, 24 June 2019
# Last updated FL, 23 July 2020

#-- user parameters

dir0="input_files/SEM46_input_files"

dir_in="$dir0/input_run_simulation_in_simple_synthetic_model_v8a_2-horizontal-layers"
file_in="$dir_in/build_simple_synthetic_model_3D.in"

dir_ou="$dir0/acquis"

reverse_x_and_y=false

nx_src=1      # nb of sources in x-direction
ny_src=1      # nb of sources in y-direction

dx_src=0.     # source spacing in x-direction (in m)
dy_src=0.     # source spacing in y-direction

x0_src=250.   # location of "1st" source (in m)
y0_src=1000.

nx_rec=450    # nb of receivers in x-direction (i.e. nb of recs per "line")
ny_rec=1      # nb of receivers in y-direction (i.e. nb of "lines")

dx_rec=10.    # receiver spacing in x-direction (i.e. within one "line", in m)
dy_rec=0.     # receiver spacing in y-direction (i.e. "line" spacing)

x0_rec=260.   # location of "1st" receiver (in m)
y0_rec=1000.

xmargin=249.  # min. margin (in m) between 1st/last src/rec and the edge of the model (in m)
              # (just used for check)

file_ou1="$dir_ou/acqui_${nx_src}x${ny_src}-srcs_${nx_rec}x${ny_rec}-recs_drec-${dx_rec}x${dy_rec}m"
file_ou2="${file_ou1}_id"
# NB: it is convenient to keep source and receiver IDs for further data
#     handling, but it is not compatible with Seiscope's convention and
#     causes problems in Seiscope PyTools (not that much in SEM46), so
#     we keep them in a separate file.

#-- end user parameters


echo
echo "Make acqui file in"
echo "  $dir_ou"
mkdir -p $dir_ou
echo


#-- init.
rm $file_ou1 $file_ou2

#-- read domain size from build_simple_synthetic_model_3D.in
zmin=$(awk <$file_in 'NR==2 {print $1}')
zmax=$(awk <$file_in 'NR==2 {print $2}') 
xmin=$(awk <$file_in 'NR==3 {print $1}') 
xmax=$(awk <$file_in 'NR==3 {print $2}')
ymin=$(awk <$file_in 'NR==4 {print $1}') 
ymax=$(awk <$file_in 'NR==4 {print $2}') 

#-- loop over sources (NB: the order matters because we want to get
#   lines of sources along the x-axis)
for ((iy_src=1; iy_src<=$ny_src; iy_src++)); do
   for ((ix_src=1; ix_src<=$nx_src; ix_src++)); do

      xsrc=$(echo "$x0_src + ($ix_src-1)*$dx_src" | bc -l)
      ysrc=$(echo "$y0_src + ($iy_src-1)*$dy_src" | bc -l)

      name_xsrc=$(echo "$ix_src" | awk '{printf "%4i", $1+1000}')
      name_ysrc=$(echo "$iy_src" | awk '{printf "%4i", $1+1000}')

      # check that source is well within margins
      if (( $(echo "$xsrc<$xmin+$xmargin" | bc -l) )) || \
         (( $(echo "$xsrc>$xmax-$xmargin" | bc -l) )) || \
         (( $(echo "$ysrc<$ymin+$xmargin" | bc -l) )) || \
         (( $(echo "$ysrc>$ymax-$xmargin" | bc -l) )) ; then
         echo "Error: source is not within margins."
         rm $file_ou1 $file_ou2
         exit
      fi

      # add source to acqui file (note the last "0" to make it a source in Seiscope's convention)
      echo "0.0 $xsrc $ysrc 0 0 0" | \
      awk '{printf "%3.1f   %9.3f   %9.3f   %i   %i   %i\n", $1, $2, $3, $4, $5, $6}' >>$file_ou1

      # add source to acqui file (with ID, convenient for further
      # processing but not compatible with Seiscope PyTools)
      echo "0.0 $xsrc $ysrc 0 0 0 $name_ysrc.$name_xsrc" | \
      awk '{printf "%3.1f   %9.3f   %9.3f   %i   %i   %i   %s\n", $1, $2, $3, $4, $5, $6, $7}' >>$file_ou2

      #-- loop over receivers (NB: the order matters, because we want to
      #   get lines of receivers along the x-axis)
      for ((iy_rec=1; iy_rec<=$ny_rec; iy_rec++)); do
         for ((ix_rec=1; ix_rec<=$nx_rec; ix_rec++)); do

            xrec=$(echo "$x0_rec + ($ix_rec-1)*$dx_rec" | bc -l)
            yrec=$(echo "$y0_rec + ($iy_rec-1)*$dy_rec" | bc -l)

            name_xrec=$(echo "$ix_rec" | awk '{printf "%4i", $1+1000}')
            name_yrec=$(echo "$iy_rec" | awk '{printf "%4i", $1+1000}')

            # check that receiver is well within margins
            if (( $(echo "$xrec<$xmin+$xmargin" | bc -l) )) || \
               (( $(echo "$xrec>$xmax-$xmargin" | bc -l) )) || \
               (( $(echo "$yrec<$ymin+$xmargin" | bc -l) )) || \
               (( $(echo "$yrec>$ymax-$xmargin" | bc -l) )) ; then
               echo "Error: receiver is not within margins."; echo
               echo "       xrec, yrec = $xrec, $yrec"
               rm $file_ou1 $file_ou2
               exit
            fi

            if (( $(echo "($xsrc-$xrec)*($xsrc-$xrec) < 0.001" | bc -l) )) && \
               (( $(echo "($ysrc-$yrec)*($ysrc-$yrec) < 0.001" | bc -l) )) ; then
               continue   # skip rec if colocated with src
            else
               # add receiver to acqui file (note the last "1" to make it a receiver in Seiscope's convention)
               echo "0.0 $xrec $yrec 0 0 1" | \
               awk '{printf "%3.1f   %9.3f   %9.3f   %i   %i   %i\n", $1, $2, $3, $4, $5, $6}' >>$file_ou1

               # add receiver to acqui file (with ID, convenient for further
               # processing but not compatible with Seiscope PyTools)
               echo "0.0 $xrec $yrec 0 0 1 $name_yrec.$name_xrec" | \
               awk '{printf "%3.1f   %9.3f   %9.3f   %i   %i   %i   %s\n", $1, $2, $3, $4, $5, $6, $7}' >>$file_ou2
            fi

         done   #-- end loop over iy_rec
      done   #-- end loop over ix_rec

   done   #-- end loop over iy_src
done   #-- end loop over ix_src


if $reverse_x_and_y ; then
   echo; echo "reverse x and y..."; echo
   mv $file_ou1 tmp1
   mv $file_ou2 tmp2
   awk <tmp1 '{printf "%3.1f   %9.3f   %9.3f   %i   %i   %i\n"     , $1, $3, $2, $4, $5, $6    }' >$file_ou1
   awk <tmp2 '{printf "%3.1f   %9.3f   %9.3f   %i   %i   %i   %s\n", $1, $3, $2, $4, $5, $6, $7}' >$file_ou2
   rm tmp1 tmp2
fi


